--- old/usr/src/uts/intel/ia32/os/archdep.c	2014-01-14 16:17:30.692820297 +0000
+++ new/usr/src/uts/intel/ia32/os/archdep.c	2014-01-14 16:17:30.706231674 +0000
@@ -632,6 +632,8 @@
 static greg_t
 fix_segreg(greg_t sr, int iscs, model_t datamodel)
 {
+	kthread_t *t = curthread;
+	
 	switch (sr &= 0xffff) {
 
 	case 0:
@@ -667,6 +669,19 @@
 		break;
 	}
 
+ 	/*
+	 * Allow this process's brand to do any necessary segment register
+	 * manipulation.
+	 */
+	if (PROC_IS_BRANDED(t->t_procp) && BRMOP(t->t_procp)->b_fixsegreg) {
+		greg_t bsr = BRMOP(t->t_procp)->b_fixsegreg(sr, datamodel);
+
+		if (bsr == 0 && iscs == IS_CS)
+			return (0 | SEL_UPL);
+		else
+			return (bsr);
+	}
+
 	/*
 	 * Force it into the LDT in ring 3 for 32-bit processes, which by
 	 * default do not have an LDT, so that any attempt to use an invalid
